
/*
	util.c
*/

#include "simpledownload.h"
#ifdef _MSC_VER
#pragma hdrstop
#endif

#include "util.h"
#include "resource.h"

BOOL
CloneWndclass(HWND hWnd)
{
	char cls_name[256] ;
	HINSTANCE hInst ;
	WNDCLASS wc ;
	int i ;

	hInst = (HINSTANCE)GetClassLong(hWnd, GCL_HMODULE) ;
	if(!hInst)
		return FALSE ;

	if(GetClassName(hWnd, cls_name, sizeof(cls_name)) == 0)
		return FALSE ;

	if(GetClassInfo(hInst, cls_name, &wc) == 0)
		return FALSE ;

	for(i = 0 ; ; i++)
	{
		strcat((char*)wc.lpszClassName, "Z") ;

		if(RegisterClass(&wc))
			break ;
	}

	return TRUE ;
}

BOOL
init_winsock()
{
	WSADATA wsad ;
	int nErr = WSAStartup(MAKEWORD(1, 1), &wsad) ;
	if(nErr != 0)
	{
		MessageBox(
		 0,
		 load_string(IDS_INITWINSOCK1_1FAILED),
		 g_szAppName,
		 MB_ICONERROR) ;
		return FALSE ;
	}
	
	return TRUE ;
}

INLINE void
get_size_str(int size, char buf[])
{
	if(size > 1024)	/* if kiro */
	{
		size /= 1024 ;
		wsprintf(buf, "%dKB", size) ;
	}
	else
		wsprintf(buf, "%dB", size) ;
}

const char*
get_without_path(const char *s)
{
	const char *p ;

	p = strrchr(s, '\\') ;
	if(p)
		p++ ;
	else
		p = s ;

	return p ;
}

static void
set_wnd_text(HWND hWnd, const char *text)
{
	char *old_text ;
	int len ;

	len = GetWindowTextLength(hWnd) ;
	if(len == 0 && text[0] != '\0')
	{
		SetWindowText(hWnd, text) ;
		return ;
	}

	old_text = (char*)alloca(len + 1) ;
	GetWindowText(hWnd, old_text, len + 1) ;

	if(strcmp(text, old_text) != 0)	/* if not equal */
		SetWindowText(hWnd, text) ;
}

void
set_progress_text(HWND hWnd, int max, int pos, const char *filename)
{
	static int
	 status = 0 ;
	char text[1024], pos_s[64], max_s[64] ;

	status++ ;
	if(0 <= status && status <= 3)
		SetClassLong(hWnd, GCL_HICON, (LONG)LoadIcon(ghInst, (LPCTSTR)IDI_APP)) ;
	
	else if(4 <= status && status <= 7)
		SetClassLong(hWnd, GCL_HICON, (LONG)LoadIcon(ghInst, (LPCTSTR)IDI_APP2)) ;

	status = status % 8 ;

	get_size_str(pos, pos_s) ;
	get_size_str(max, max_s) ;
	
	wsprintf(
	 text,
	 "%d%% - %s (%s/%s)",
	 pos * 100 / max,			/* percent */
	 get_without_path(filename),
	 pos_s,
	 max_s) ;

	set_wnd_text(hWnd, text) ;
}

void
set_pause_text(HWND hWnd, const char *filename)
{
	static const char *pause_s ;
	char text[1024] ;

	if(!pause_s)
		pause_s = strdup(load_string(IDS_PAUSE)) ;

	wsprintf(
	 text,
	 "%s - %s",
	 pause_s,
	 get_without_path(filename)) ;

	set_wnd_text(hWnd, text) ;
}
